<?php
!defined('NoRead') && exit;

/*E-Tag Read/Write*/

$new = false;

function e_tag (&$new, $n = true) {
	global $RegModule, $MySQLi;
	if ($n && isset($_SERVER['HTTP_IF_NONE_MATCH'])) {
		$InETag = trim((string)$_SERVER['HTTP_IF_NONE_MATCH'], " \t\r\n\x00\x0B\"'`");
		$InETag_ln = strlen($InETag);
		if ($InETag_ln === 27 && preg_match("/^([a-f0-9]{8}\-[a-f0-9]{4}\-[a-f0-9]{13})*$/isD" , $InETag, $data))
			return next($data);
		
	}
	$new = true;
	while (true) {
		$e_tag = $RegModule->saltgen(128, 'e_tag');
		$MyAuto = $MySQLi->MySQLi->query('SELECT null FROM `autoEtag` WHERE etag = "'.$e_tag.'"') 
				or die(Log::logu('Error', 'Невозможно считать данные E-tag из БД, '.$MySQLi->MySQLi->error));
		$MySQLi->MySQLi->store_result();
		if($MyAuto->num_rows === 0) {
			$MyAuto->close();
			return $e_tag;
			break;
		}
	}
}

$e_tag = e_tag($new);

switch ($new) {	
case false:
	$MyAuto = $MySQLi->MySQLi->prepare('SELECT `id` FROM `autoEtag` WHERE etag = ?;');
	$MyAuto -> bind_param('s', $e_tag);
	$MyAuto -> execute() or die(Log::logu('Error', 'Невозможно занести данные 1 E-tag в БД, '.$MySQLi->MySQLi->error));
	$MyAuto -> bind_result($bID);
	$MyAuto -> store_result();
	$count = $MyAuto -> num_rows;
	if ($count === 1) {
		$MyAuto->fetch();
		$info->uid = $bID;
		$MyAuto -> close();
		break;
	} elseif($count > 1) {
		Log::logg('Warning', 'В таблице auto обнаружены две записи с одинаковым  E-Tag: '.$e_tag);		
	}
		$MyAuto -> close();
		$e_tag = e_tag($new, false);
case true:
	$new = true;
	$MyAuto = $MySQLi->MySQLi->prepare('INSERT INTO `autoEtag` (`id` ,`etag`) VALUES (NULL , ?);');
	$MyAuto -> bind_param('s', $e_tag);
	$MyAuto -> execute() or die(Log::logu('Error', 'Невозможно занести данные 2 E-tag в БД, '.$MySQLi->MySQLi->error));
	$info->uid = $MySQLi->MySQLi->insert_id;
	$MyAuto -> close();
	break;
}


$Header['ETag'] = array(/*Cache = 1, NoCache = 0*/(int)(!$new), $e_tag);


unset($new, $count, $e_tag);
